Draft Série de copies

From FreeCAD Documentation
Jump to: navigation, search
This page is a translated version of the page Draft PathArray and the translation is 17% complete.

Outdated translations are marked like this.
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎italiano • ‎română • ‎русский • ‎svenska • ‎Türkçe
Arrow-left.svg Previous: Draft Array.svg Array

Draft PathArray.svg Draft PathArray

Emplacement du menu
Draft → PathArray
Ateliers
Draft, Arch
Raccourci par défaut
Aucun
Introduit dans la version
-
Voir aussi
Draft Array


Description

L'outil PathArray place des copies d'une forme sélectionnée le long d'un chemin sélectionné. Le chemin peut être un fil ou une ou plusieurs arêtes. Les formes peuvent éventuellement être alignées sur la tangente du tracé. Si nécessaire, un ajustent des vecteurs peut être spécifié pour déplacer les formes afin que le centre de gravité se trouve sur le chemin. Si aucun objet n'est sélectionné, vous serez invité à sélectionner un objet.

The PathArray tool can be used on 2D shapes created with the Draft Workbench, but can also be used on many types of 3D objects such as those created with the Part, PartDesign, or Arch Workbenches.

To position copies in an orthogonal array use Draft Array; to position copies at specified points use Draft PointArray; to create copies or clones, and manually place them use Draft Move, Draft Rotate, and Draft Clone.

Draft PathArray Example.png

Object arranged along a path


Utilisation

  1. Créez un objet de forme que vous souhaitez distribuer. Vous obtiendrez les meilleurs résultats si votre objet est centré sur l'origine, même si le chemin commence ailleurs.
  2. Sélectionnez l'objet que vous souhaitez distribuer.
  3. Sélectionnez un tracé le long de laquelle les formes seront copiées. -ou-
  4. Sélectionner les bords d'un objet qui servirons de chemin.
  5. Pressez le bouton Draft PathArray.png Draft PathArray.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

The base object should be centred around the origin, even if the path starts somewhere else.

Options

  • Le tableau commence avec des copies de formes qui ne sont pas alignées sur le chemin, ni traduites vers un nouvel emplacement par défaut. Vous pouvez ensuite changer le nombre, l'alignement et/ou l'adaptation des vecteurs dans les propriétés.

Propriétés

  • DONNÉESBase: L'objet shape
  • DONNÉESPathObj: Le chemin de l'objet
  • DONNÉESPathSubs: Les sous-éléments (bords) de l'objet trajectoire pour être utilisé comme chemin
  • DONNÉESCount: Le nombre de copies du shape
  • DONNÉESXlate: L'adaptation du vecteur
  • DONNÉESAlign: True aligne le shape sur le chemin, False laisse le shape sur une orientation par défaut.

Script

L'outil PathArray peut être utilisé dans une macro et dans la console python avec la commande

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Place le nombre de copies d'un objet le long d'un chemin ou sous-objet d'un objet qui servira de chemin. Transforme éventuellement chaque copie avec FreeCAD.Vector le vecteur XLATE donne la direction et la distance pour ajuster la différence entre le centre de la forme vers le point de référence de la forme. Aligne éventuellement BaseObject à la tangente/normale/binormale du chemin.

Exemple:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Explication technique

Quand "Align = false", la logique de PathArray est assez facile à comprendre.

Align false
Align false

Object arranged along a closed path in the original orientation


Lorsque "Align = True" la logique est un peu plus difficile à saisir:

  1. Construire un système de coordonnées Frenet sur le chemin (X est tangent, Z est normal, Y est binormal).
  2. Copiez l'objet d'origine dans chaque système de coordonnées sur le trajet, de sorte que l'origine globale corresponde à l'origine du système de coordonnées sur le trajet.
Patharray alignment annotated.png
Patharray alignment annotated.png

Object arranged along a closed path; description of components and path


C'est beaucoup plus facile à comprendre avec des images. Les images suivantes montrent comment le tableau est produit, en fonction du plan et du chemin.

XY Plane

Chemin sur le Plan XY

XZ Plane

Chemin sur le Plan XZ

YZ Plane

Chemin sur le Plan YZ

Patharray alignment.png

Object arranged along a closed path which is aligned to the XY plane


Path on XZ Plane:

Patharray alignment-XZ.png

Object arranged along a closed path which is aligned to the XZ plane


Path on YZ Plane:

Patharray alignment-YZ.png

Object arranged along a closed path which is aligned to the YZ plane


L'avantage évident de cette logique est que lorsque vous réorientez le chemin mais pas l'objet, le résultat est cohérent: l'objet reste aligné sur le chemin tel qu'il était avant de réorienter le chemin.

(Remerciements à @DeepSOIC pour ces explications)

Arrow-left.svg Previous: Draft Array.svg Array